/*
 * Created on 28.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.jvnet.jaxbcommons.cloneable.addon.generator;

import org.jvnet.jaxbcommons.addon.generator.AbstractMethodStrategy;
import org.jvnet.jaxbcommons.lang.Cloneable;
import org.jvnet.jaxbcommons.util.AccessorUtils;
import org.jvnet.jaxbcommons.util.FieldUtils;

import com.sun.codemodel.JBlock;
import com.sun.codemodel.JCodeModel;
import com.sun.codemodel.JConditional;
import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JExpr;
import com.sun.codemodel.JMethod;
import com.sun.codemodel.JMod;
import com.sun.codemodel.JStatement;
import com.sun.codemodel.JVar;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.ClassItem;
import com.sun.tools.xjc.grammar.FieldItem;
import com.sun.tools.xjc.grammar.FieldUse;

/**
 * 
 * @author valikov
 */
public class CloneableStrategy extends AbstractMethodStrategy {

  public JMethod generate(ClassContext classContext, FieldItem fieldItem, JDefinedClass theClass) {

    classContext.ref._implements(Cloneable.class);

    final JCodeModel codeModel = getCodeModel(classContext);
    final JMethod clone = classContext.implClass.method(
        JMod.PUBLIC,
        codeModel.ref(Object.class),
        "clone");

    final JDefinedClass theInterface = classContext.ref;
    final JBlock body = clone.body();
    final JVar cloned = body.decl(JMod.FINAL, theInterface, "cloned", JExpr._new(theClass));

    for (ClassItem item = classContext.target; item != null; item = item.getSuperClass()) {
      final ClassContext context = classContext.parent.getClassContext(item);
      generateFieldsCopy(context, body, cloned);
    }
    body._return(cloned);
    return clone;
  }

  /**
   * Generates field equality check instructions.
   *
   * @param classContext class context.
   * @param methodBody   method body.
   * @param target       target variable.
   */
  protected void generateFieldsCopy(
      final ClassContext classContext,
      final JBlock methodBody,
      final JVar target) {
    final FieldUse[] fieldUses = classContext.target.getDeclaredFieldUses();
    // Iterate over field uses
    for (int index = 0; index < fieldUses.length; index++) {
      final FieldUse fieldUse = fieldUses[index];
      final FieldItem fieldItem = FieldUtils.getFieldItem(fieldUse);
//      fieldItem.
      final JMethod getter = AccessorUtils.get(classContext, fieldItem);
      final JMethod isSetter = AccessorUtils.isSet(classContext, fieldItem);
      final JMethod unsetter = AccessorUtils.unset(classContext, fieldItem);
      if (getter != null) {
        final JBlock block = methodBody.block();
        block.invoke(target, unsetter);

        final JConditional ifSet = block._if(JExpr.invoke(isSetter));
        final JBlock ifSetThen = ifSet._then();

        final JStatement st = (JStatement) fieldItem.visit(new FieldCopyVisitor(
            classContext,
            target,
            JExpr._this()));
        ifSetThen.add(st);
      }
    }
  }
}
