/*
 * Created on 28.06.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.jvnet.jaxbcommons.extendedcloneable.addon.generator;

import org.jvnet.jaxbcommons.addon.generator.AbstractMethodStrategy;
import org.jvnet.jaxbcommons.lang.CloneAware;
import org.jvnet.jaxbcommons.lang.Cloneable;
import org.jvnet.jaxbcommons.lang.ClonedObjects;
import org.jvnet.jaxbcommons.util.AccessorUtils;
import org.jvnet.jaxbcommons.util.FieldUtils;

import com.sun.codemodel.JBlock;
import com.sun.codemodel.JCodeModel;
import com.sun.codemodel.JConditional;
import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JExpr;
import com.sun.codemodel.JMethod;
import com.sun.codemodel.JMod;
import com.sun.codemodel.JStatement;
import com.sun.codemodel.JVar;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.ClassItem;
import com.sun.tools.xjc.grammar.FieldItem;
import com.sun.tools.xjc.grammar.FieldUse;

/**
 * 
 * @author valikov
 */
public class VisitCloneStrategy extends AbstractMethodStrategy {

  public JMethod generate(ClassContext classContext, FieldItem fieldItem, JDefinedClass theClass) {

    classContext.ref._implements(CloneAware.class);

    final JCodeModel codeModel = getCodeModel(classContext);

    final JMethod visitClone = classContext.implClass.method(JMod.PUBLIC, codeModel
        .ref(Object.class), "visitClone");

    final JVar clonedObjects = visitClone.param(ClonedObjects.class, "clonedObjects");

    final JDefinedClass theInterface = classContext.ref;
    final JBlock body = visitClone.body();

    final JConditional ifCloned = body._if(clonedObjects.invoke("isCloned").arg(JExpr._this()));
    ifCloned._then()._return(clonedObjects.invoke("getClone").arg(JExpr._this()));
    final JBlock block = ifCloned._else();
    {
      final JVar cloned = block.decl(JMod.FINAL, theInterface, "cloned", JExpr._new(theClass));
      block.invoke(clonedObjects, "addCloned").arg(JExpr._this()).arg(cloned);

      for (ClassItem item = classContext.target; item != null; item = item.getSuperClass()) {
        final ClassContext context = classContext.parent.getClassContext(item);
        generateFieldsCopy(context, block, cloned, clonedObjects);
      }
      block._return(cloned);
    }
    return visitClone;
  }

  /**
   * Generates field equality check instructions.
   *
   * @param classContext class context.
   * @param methodBody   method body.
   * @param target       target variable.
   * @param clonedObjects 
   */
  protected void generateFieldsCopy(
      final ClassContext classContext,
      final JBlock methodBody,
      final JVar target,
      final JVar clonedObjects) {
    final FieldUse[] fieldUses = classContext.target.getDeclaredFieldUses();
    // Iterate over field uses
    for (int index = 0; index < fieldUses.length; index++) {
      final FieldUse fieldUse = fieldUses[index];
      final FieldItem fieldItem = FieldUtils.getFieldItem(fieldUse);
      //      fieldItem.
      final JMethod getter = AccessorUtils.get(classContext, fieldItem);
      final JMethod isSetter = AccessorUtils.isSet(classContext, fieldItem);
      final JMethod unsetter = AccessorUtils.unset(classContext, fieldItem);
      if (getter != null) {
        final JBlock block = methodBody.block();
        block.invoke(target, unsetter);

        final JConditional ifSet = block._if(JExpr.invoke(isSetter));
        final JBlock ifSetThen = ifSet._then();

        final JStatement st = (JStatement) fieldItem.visit(new FieldCopyVisitor(
            classContext,
            target,
            JExpr._this(),
            clonedObjects));
        ifSetThen.add(st);
      }
    }
  }
}
