package org.jvnet.jaxbcommons.extendedhashcode.addon.generator;

import org.jvnet.jaxbcommons.addon.generator.AbstractMethodStrategy;
import org.jvnet.jaxbcommons.addon.generator.MethodStrategy;
import org.jvnet.jaxbcommons.lang.impl.DefaultVisitedObjects;

import com.sun.codemodel.JCodeModel;
import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JExpr;
import com.sun.codemodel.JMethod;
import com.sun.codemodel.JMod;
import com.sun.tools.xjc.generator.ClassContext;
import com.sun.tools.xjc.grammar.FieldItem;

public class HashCodeStrategy extends AbstractMethodStrategy {

  private MethodStrategy visitHashCodeStrategy = new VisitHashCodeStrategy();

  public JMethod generate(ClassContext classContext, FieldItem fieldItem, JDefinedClass theClass) {
    final JCodeModel codeModel = getCodeModel(classContext);

    final JMethod visitHashCode = visitHashCodeStrategy.generate(classContext, fieldItem, theClass);

    final JMethod hashCode = classContext.implClass.method(JMod.PUBLIC, codeModel.INT, "hashCode");
    hashCode.body()._return(
        JExpr.invoke(visitHashCode).arg(
            JExpr._new(theClass.owner().ref(DefaultVisitedObjects.class))));
    return hashCode;
  }
}
